var Blaster = {
  onLoad: function() {
    // Get the quick list URL
    var prefs = Components.classes["@mozilla.org/preferences-service;1"].
                    getService(Components.interfaces.nsIPrefBranch);
    var uri = prefs.getCharPref("extensions.termblaster.opened.quicklist").replace(/^\s*|\s*$/g, "");
    if (uri.length == 0) {
      return false;
    }

    // Executes after the XML file has been loaded
    var XMLDoc = document.implementation.createDocument("", "", null);
    XMLDoc.async = false;
    XMLDoc.onload = function () {
      var iNode = XMLDoc.documentElement;
      var cNode;
      for (var i = 0; i < iNode.childNodes.length; i++) {
        cNode = iNode.childNodes.item(i);
        if (cNode != null
         && cNode.localName != null
         && cNode.localName == 'service') {
          lbSearch.appendItem(cNode.attributes.getNamedItem("name").nodeValue, cNode.attributes.getNamedItem("query").nodeValue);
        }
      }
    }

    // Loaded items will be stored here:
    var lbSearch = document.getElementById("services");

    // Load an XML file
    try {
      XMLDoc.load(uri);
    } catch (e) {
      alert("termBlaster could not load selected file ('" + uri + "'): " + e.message);
    }
  },

  onKeyPress: function(event) {
    if (event.keyCode == event.DOM_VK_RETURN) {
      var term = document.getElementById("search").value;
      document.getElementById("terms").appendItem(term, term);
      document.getElementById("search").value = '';
    }
  },

  onChangeSelection: function() {
    // Get the selected term
    // If none is selected, then the first is assumed
    if (document.getElementById("terms").selectedItem != null) {
      var term = document.getElementById("terms").selectedItem.value.replace(/^\s*|\s*$/g,"");
    } else if (document.getElementById("terms").getItemAtIndex(0) != null) {
      var term = document.getElementById("terms").getItemAtIndex(0).value.replace(/^\s*|\s*$/g,"");
    } 

    // If term is defined, then return
    if (typeof(term) == "undefined") {
      return;
    }

    // Get the query in a similiar fasion as the term
    if (document.getElementById("services").selectedItem != null) {
      var query = document.getElementById("services").selectedItem.value.replace('\$s', encodeURIComponent(term));
    } else if (document.getElementById("services").getItemAtIndex(0) != null) {
      var query = document.getElementById("services").getItemAtIndex(0).value.replace('\$s', encodeURIComponent(term));
    }

    // If query is empty then return
    if (typeof(query) == "undefined" && query.length == 0) {
      return;
    }

    // Load the results in the current window
    var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                       .getService(Components.interfaces.nsIWindowMediator);
    var win = wm.getMostRecentWindow("navigator:browser");
    win.getBrowser().loadURI(query);
  }
}
